<?
/* 
 * EDOMI beta (Version 1.50) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
-----------------------------------------------------------------------------------------------------------------------------------------
Controltyp 20 - Kamera (Livebild und Archiv)
(Livebild wird nur aufgerufen, wenn Bildschirmschoner inaktiv ist)
-----------------------------------------------------------------------------------------------------------------------------------------
*/
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");
require(MAIN_PATH."/www/shared/php/incl_camera.php");

//Eigene Includes
require(MAIN_PATH."/www/visu/include/php/config.php");
require(MAIN_PATH."/www/visu/include/php/base.php");


sql_connect();

if (checkVisuSid($visuId,$sid)) {cmd($cmd);}

function cmd($cmd) {
	global $appId,$visuId,$pageId,$data,$dataArr,$phpdata,$phpdataArr,$sid;
	global $global_weekdays;

	if ($cmd=='camLive') {

		if ($dataArr[2]==-1) {
			//direktes MJPEG-Streaming
			$ss1=sql_call("SELECT url FROM edomiLive.cam WHERE (id=".$dataArr[1]." AND mjpeg=1)");
			if ($n=sql_result($ss1)) {
?>
				var imgDiv=document.getElementById("e-<?echo $dataArr[0];?>-imglive");
				if (imgDiv) {
					imgDiv.innerHTML="<iframe id='e-<?echo $dataArr[0];?>-stream' src='about:blank' style='position:absolute; left:0; top:0; width:100%; height:100%; margin:0; padding:0; border:none; pointer-events:none; overflow:hidden;'></iframe>"
					var iframe=document.getElementById("e-<?echo $dataArr[0];?>-stream");
					if (iframe) {
						iframe.contentWindow.document.open('text/htmlreplace');
						iframe.contentWindow.document.write("<html><body style='background:transparent; margin:0; padding:0; -webkit-user-select:none;'><img draggable='false' style='position:absolute; left:0; top:0; width:100%; height:100%;' src='<?ajaxValue($n['url']);?>'></body></html>");
						iframe.contentWindow.document.close();
						control20_SetTimer(<?echo $dataArr[0];?>,true);
					}
				}
<?
			}

		} else {

			//Livebild holen
			$img=getVisuLiveCamImg($dataArr[1]);
			if ($img!==false) {
				//Bild anzeigen und Timer setzen (nach dem Laden des Bildes)
?>
				var img=document.getElementById("e-<?echo $dataArr[0];?>-imglive");
				if (img) {
					img.src="../data/liveproject/cam/live/<?echo $img;?>?ts=<?echo getTimestampId();?>";
					img.onload=function() {control20_SetTimer(<?echo $dataArr[0];?>,true);}
					img.onerror=function() {control20_SetTimer(<?echo $dataArr[0];?>,false);}
				}
<?
			} else {
				//Bild-Fehler => neuer Versuch (und Bild als fehlerhaft kennzeichnen)
?>
				control20_SetTimer(<?echo $dataArr[0];?>,false);
<?
			}
		}
	}


	if ($cmd=='camArchiv') {

		$ss2=sql_call("SELECT * FROM edomiLive.archivCam WHERE (id=".$dataArr[4].")");
		if ($nn=sql_result($ss2)) {
			$archivName=$nn['name'];
		} else {
			$archivName='???';
		}

		//mode=1: vor, =-1: zurück, 0=aktuellster Eintrag
		if ($dataArr[1]==0) { //aktuellsten Eintrag (dies ist Default beim Öffnen)
			$ss1=sql_call("SELECT * FROM edomiLive.archivCamData WHERE (targetid=".$dataArr[4].") ORDER BY datetime DESC,ms DESC LIMIT 0,1");
		}
		if ($dataArr[1]==1) { //Navigation: Älteres Bild
			$ss1=sql_call("SELECT * FROM edomiLive.archivCamData WHERE (targetid=".$dataArr[4]." AND CONCAT(datetime,LPAD(ms,6,'0'))<'".$dataArr[2]."') ORDER BY datetime DESC,ms DESC LIMIT 0,1");
		}
		if ($dataArr[1]==-1) { //Navigation: Jüngeres Bild
			$ss1=sql_call("SELECT * FROM edomiLive.archivCamData WHERE (targetid=".$dataArr[4]." AND CONCAT(datetime,LPAD(ms,6,'0'))>'".$dataArr[2]."') ORDER BY datetime ASC,ms ASC LIMIT 0,1");
		}

		if ($n=sql_result($ss1)) {
			$fn=getArchivCamFilename($n['targetid'],$n['camid'],$n['datetime'],$n['ms']).'.jpg';
?>
			document.getElementById("e-<?echo $dataArr[0];?>").dataset.cursor="<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>";
			document.getElementById("e-<?echo $dataArr[0];?>-infotext").innerHTML="<?echo ajaxValueHTML($archivName);?><br><?echo $global_weekdays[date('N',strtotime($n['datetime']))-1];?> / <?echo sql_getDateTime($n['datetime']);?><span style='opacity:0.75;'>.<?echo sprintf("%06d",$n['ms']);?></span>";
			document.getElementById("e-<?echo $dataArr[0];?>-reloadanim").style.display="inline";
			document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv").onload=function() {document.getElementById("e-<?echo $dataArr[0];?>-reloadanim").style.display="none";}
			document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv").onerror=function() {document.getElementById("e-<?echo $dataArr[0];?>-reloadanim").style.display="none";}
<?
			if (file_exists(MAIN_PATH.'/www/data/liveproject/cam/archiv/'.$fn)) {
?>  
				document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv").src="../data/liveproject/cam/archiv/<?echo $fn;?>?ts=<?echo getTimestampId();?>";
<?
			} else {
?>
				document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv").src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQIHWP4//8/AwAI/AL+5gz/qwAAAABJRU5ErkJggg==";
				document.getElementById("e-<?echo $dataArr[0];?>-reloadanim").style.display="none";
<?
			}
		} else if ($dataArr[1]==0) {
?>
			document.getElementById("e-<?echo $dataArr[0];?>").dataset.cursor="";
			document.getElementById("e-<?echo $dataArr[0];?>-infotext").innerHTML="<?echo ajaxValueHTML($archivName);?>";
			document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv").src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQIHWP4//8/AwAI/AL+5gz/qwAAAABJRU5ErkJggg==";
			document.getElementById("e-<?echo $dataArr[0];?>-reloadanim").style.display="none";
<?
		}
	}
}

sql_disconnect();
?>

