/* 
 * EDOMI beta (Version 1.50) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 22 (Zeitschaltuhr)
//----------------------------

function control22_construct(obj,id,gaid,title) {

	var mheight=(obj.dataset.var10!='')?obj.dataset.var10:40;

	var n="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<tr style='height:"+mheight+"px;'>";
			n+="<td width='20%' align='center' id='e-"+id+"-last'>&larr;</td>";
			n+="<td width='60%' align='center' id='e-"+id+"-info'><div id='e-"+id+"-infotext' style='max-height:"+mheight+"px; overflow:hidden;'>"+title+"</div></td>";
			n+="<td width='20%' align='center' id='e-"+id+"-next'>&rarr;</td>";
		n+="</tr>";
		n+="<tr><td colspan='3' align='center' style='border-top:1px solid;"+((obj.dataset.var3>0)?"border-bottom:1px solid;":"")+"'><div style='position:relative; height:100%;'><div id='e-"+id+"-edit' style='position:absolute; top:0; left:0; right:0; bottom:0; overflow-x:hidden; overflow-y:auto;'></div></div></td></tr>";
	if (obj.dataset.var3>0) {
		n+="<tr style='height:"+mheight+"px;'><td colspan='3'>";
			n+="<table cellpadding='0' cellspacing='0' border='0' style='width:100%; height:100%;'>";
				n+="<tr align='center'>";
		if (obj.dataset.var3 & 1) {n+="<td id='e-"+id+"-off'><div id='e-"+id+"-status0' style='max-height:"+mheight+"px; overflow:hidden; display:inline-block; border:1px solid transparent; border-radius:3px; padding:1px;'>aus</div></td>";}
		if (obj.dataset.var3 & 2) {n+="<td id='e-"+id+"-add'><div style='max-height:"+mheight+"px; overflow:hidden; display:inline-block;'>+</div></td>";}
		if (obj.dataset.var3 & 1) {n+="<td id='e-"+id+"-on'><div id='e-"+id+"-status1' style='max-height:"+mheight+"px; overflow:hidden; display:inline-block; border:1px solid transparent; border-radius:3px; padding:1px;'>ein</div></td>";}
				n+="</tr>";
			n+="</table>";
		n+="</td></tr>";
	}
	n+="</table>";
	obj.innerHTML=n;
		
	obj.dataset.cursor=0;
	control22_ShowInfo(id);

	document.getElementById("e-"+id+"-last").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollUp("e-"+id+"-edit");},false);
	document.getElementById("e-"+id+"-info").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control22_ShowInfo(id);},false);
	document.getElementById("e-"+id+"-next").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollDown("e-"+id+"-edit");},false);
	if (obj.dataset.var3 & 1) {
		document.getElementById("e-"+id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); setKoValue(gaid,0);},false);
		document.getElementById("e-"+id+"-on").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); setKoValue(gaid,1);},false);
	}
	if (obj.dataset.var3 & 2) {
		document.getElementById("e-"+id+"-add").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control22_New(id);},false);
	}
}

function control22_ShowInfo(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		d.dataset.cursor="";
		var n=elementId+AJAX_SEPARATOR1+"0"+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1;
		ajax("zsuInfo",1022,visu_visuid,0,n,"");
	}
}

function control22_New(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.var3 & 2) {
			var n=elementId+AJAX_SEPARATOR1+"0"+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1;
			ajax("zsuEdit",1022,visu_visuid,0,n,"-1");
		}
	}
}

function control22_Edit(elementId,id) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.var3 & 2) {
			var n=elementId+AJAX_SEPARATOR1+"0"+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1;
			ajax("zsuEdit",1022,visu_visuid,0,n,id);
		}
	}
}

function control22_Switch(elementId,mode) {
	var s0=document.getElementById("e-"+elementId+"-status0");
	var s1=document.getElementById("e-"+elementId+"-status1");
	if (s0 && s1) {
		if (mode==1) {
			s0.style.border="1px solid transparent";
			s1.style.border="1px solid";
		} else {
			s0.style.border="1px solid";
			s1.style.border="1px solid transparent";
		}
	}
}
